package com.monica.interfaces;

import com.monica.interfaces.*;

/** This interface provides close connections functionality for any TM hierarchy layer. 
*/    

public interface Closeable extends Configureable {

  /** Returns the internal name of the Closeable.
      @return String: the intrernal name of the Closeable
  */
  public String getCloseableName();
  
  /** Returns the internal version of the Closeable.
      @return String: the internal version of the Closeable
  */      
  public String getCloseableVersion();
  
  /** Closes all connections of the Closeable.
  */  
  public void closeConnections();
  
}