package com.monica.interfaces;

import com.monica.interfaces.*;

/** Classes of the TM layer hierarchy that can be customized with
    configuration soruces should implement this interface.
*/    
public interface Configureable {

  /** Sets the Configuration for this object.
      @param Configuration configuration: the Configuration
        object for the customization
  */	
  public void setConfiguration(Configuration configuration);
  
  /** Returns the Configuration with which this object is customized.
      @return Configuration: the Configuration with which this
        object is customized
  */	
  public Configuration getConfiguration();
  
}  
