package com.monica.interfaces;

import com.monica.interfaces.*;

/** Interface for providing the main functionality of a middle level layer in the
    TM layer hierarchy as seen from a lower level layer.
*/    
public interface LayerBottomView extends Reader, Writer, Configureable {  

  /** Returns the internal name of the LayerBottomView.
      @return String: the internal name of the LayerBottomView
  */      
  public String getLayerBottomViewName();
  
  /** Returns the internal version of the LayerBottomView.
      @return String: the internal version of the LayerBottomView
  */      
  public String getLayerBottomViewVersion();
}    