package com.monica.interfaces;

import com.monica.interfaces.*;

/** Interface for providing the main functionality of a middle level layer in the
    TM layer hierarchy as seen from an upper level layer.
*/    
public interface LayerTopView extends Readable, Writeable, Configureable {  

  /** Returns the internal name of the LayerTopView.
      @return String: the internal name of the LayerTopView
  */
  public String getLayerTopViewName();
  
  /** Returns the internal version of the LayerTopView.
      @return String: the internal version of the LayerTopView
  */
  public String getLayerTopViewVersion();            
}    