package com.monica.interfaces;

import com.monica.interfaces.*;

/** Class for implementing the Observed part of the Observer-Observed design pattern.
 */

public interface Observed {
   
    /** An Observer registeres to this Observed to be notified.
     *  @param Observer observer: the to be registered Observer
     *  @return boolean: whether the registration was successfull
     */
    public boolean registerObserver(Observer observer);
    
    /** Unregisters an Observer from this Observed.
     *  @param Observer observer: the to be unregistered Observer
     *  @return boolean: whether the unregistration was successfull
     */
    public boolean unregisterObserver(Observer observer);    
}

