package com.monica.javacom.application;

import com.monica.javacom.interfaces.*;
import com.monica.javacom.transport.*;
import com.monica.javacom.application.*;
import com.monica.util.*;
import com.monica.javacom.ssh2.*;
import com.monica.interfaces.*;
import com.monica.util.configuration.*;
import com.monica.javacom.ssh2.interfaces.*;
import com.monica.javacom.ssh2.userauthentication.*;
import com.monica.javacom.ssh2.connection.*;

import java.io.*;

public class SSH2ServerApp {
    
  public static void main(String[] args) {
      
    try {
        
      if (args.length>=1) {                            
        String loaderFile=args[0];
        
        Configuration loadedConfig=ConfigurationLoader.load(loaderFile);                  
        
        
        SSH2ServerImpl.startUp(loadedConfig, new echoer());        
      }
      else {
        System.out.println("Usage: ");
        System.out.println("java SSHServer loaderFile");
        System.exit(-1);                    
      }
    }
    catch (Exception e) {
        System.err.println("Server could not be established. Reason: "+e.toString());
        e.printStackTrace();
    }
  }
}

class echoer implements SSH2ChannelManager, com.monica.interfaces.Reader {
    
  public String getReaderName() {
    return null;
  }
  
  public String getReaderVersion() {
    return null;  
  }
  
  public void readEvent(Readable readable) {      
    String data=readable.getInput();
    if (data.charAt(0)=='x') {
      ((SSH2Channel)readable).closeConnections();
    }
    else {    
      ((Writeable)readable).write(data);
      ((Writeable)readable).flush();    
    }
  }
  
  public void connectionClosedEvent(Readable readable) {
  }
  
  public void errorEvent(String errorDescription, Readable readable) {
  }
  
  public void setReadable(Readable readable) {
  }
  
  public Readable getReadable() {
    return null;  
  }
  
  public void channelArrived(SSH2Channel channel) {
    channel.setReader(this);  
  }
  
  public void channelClosed(SSH2Channel channel) {
  }
  
  public boolean channelRequest(SSH2Channel channel, SSH2Packet pack) {
    return false;  
  }
  
  public void channelReady(SSH2Channel channel) {
    channel.write("Welcome."+SSH2Constants.CRLF);
    channel.flush();      
  }
      
}