package com.monica.javacom.interfaces;

import com.monica.javacom.interfaces.*;
import com.monica.interfaces.*;

/** This interface is responsible to close the client side application
    upon user request.
*/    

public interface Closer extends Configureable {

  /** Returns the internal name of the Closer.
      @return String: the internal name of the Closer
  */
  public String getCloserName();
  
  /** Returns the internal version of the Closer.
      @return String: the internal version of the Closer
  */      
  public String getCloserVersion();
  
  /** This method closes the client side application.
  */
  public void closeApplication();  
  
  /** Sets the Transport which is responsible for the data
      connection between the client and the server.
      @param Transport transport: the Transport that is
        responsible for the data connection between client and server
  */	
  public void setTransport(Transport transport);
  
  /** Sets the Window that represents the user interface of the client 
      side.
      @param Window window: the Window that represents the 
        user interface of the client side
  */	
  public void setWindow(Window window);
}