package com.monica.javacom.interfaces;

import com.monica.javacom.interfaces.*;
import com.monica.interfaces.*;

/** This interface is responsible for the management of an Transport
    server. Currently management only means the handling of the arrival
    of new clients.
*/  
public interface ServerManager  {

  /** Returns the internal name of the ServerManager.
      @return String: the internal name of the ServerManager
  */  
  public String getServerManagerName();
  
  /** Returns the internal version of the ServerManager.
      @return String: the internal version of the ServerManager
  */       
  public String getServerManagerVersion();
  
  /** This method will be invoked from the Transport when a new 
      client arrives.
      @param Transport server: the server that has accepted the client
      @param Trabsport client: the accepted client
  */      
  public void newClientHasArrivedEvent(Transport server, Transport client);
  
  /** This method starts the ServerManager.
  */    
  public void start();
  
}    