package com.monica.javacom.interfaces;

import com.monica.javacom.interfaces.*;
import com.monica.interfaces.*;

/** Middle level layer in the TM layer hierarchy responsible for the 
    terminal funcionality, such as cursor positioning etc. 
*/    

public interface Terminal extends Writeable, Configureable, LayerBottomView {

  /** Returns the internal name of the Terminal.
      @return String: the internal name of the Terminal
  */      
  public String getTerminalName();
  
  /** Returns the internal version of the Terminal.
      @return String: the internal version of the Terminal
  */
  public String getTerminalVersion();
  
  /** Sets the VirtualDisplay for this object to which the 
      interpreted contents of the input stream have to be sent.
      @param VirtualDisplay display: the VirtualDisplay to
        which the interpreted contents have to be sent
  */	
  public void setVirtualDisplay(VirtualDisplay display);
  
  /** Returns the VirtualDisplay to which the interpreted 
      contents of the input stream will be sent.
      @return VirtualDisplay: the VirtualDisplay to which
        the interpreted contents of the input stream will be sent
  */	
  public VirtualDisplay getVirtualDisplay();
  
  public String getType();  
    
}

