package com.monica.javacom.interfaces;

import com.monica.javacom.interfaces.*;
import com.monica.interfaces.*;

/** Top level sublayer responsible for catching the user input and
    forwarding it to a middle level layer.
*/ 
public interface VirtualInput extends Configureable, Writer {

  /** Returns the internal name of the VirtualInput.
      @return String: the internal name of the VirtualInput
  */   
  public String getVirtualInputName();
  
  /** Returns the internal version of the VirtualInput.
      @return String: the internal version of the VirtualInput
  */      
  public String getVirtualInputVersion();
  
}