package com.monica.javacom.interfaces;

import com.monica.javacom.interfaces.*;
import com.monica.interfaces.*;

/** Top level sublayer responsible for holding the VirtualDisplay and
    VirtualInput objects and creating a framework for their
    functionality.
*/
public interface Window extends Configureable {

  /** Returns the internal name of the Window.
      @return String: the internal name of the Window
  */      
  public String getWindowName();
  
  /** Returns the internal version of the Window.
      @return String: the internal version of the Window
  */      
  public String getWindowVersion();
  
  /** Sets the Closer responsible for closing of the client 
      side application upon user request.
      @param tCloser closer: the tCloser reponsible for the
        closing of the client side application upon user request
  */	
  public void setCloser(Closer closer);
  
  /** Returns the Closer responsible for the closing of the
      client side application upon user request.
      @return tCloser: the Closer responsible for the closing
        of the client side application upon user request
  */	
  public Closer getCloser();
}