package com.monica.javacom.ssh2;

import java.math.*;

/** Class for providing a common way to pass the unencoded, uncompressed
    SSH2 transport protocol package between the object in the TM world.
*/    
public class SSH2Packet {

  /** The packet length as BigInteger. packet_length=5+payload.length()+padding.length(). */
  public BigInteger packet_length;
  
  /* The packet length as int. packet_length=5+payload.length()+padding.length(). */
  public int packet_length_int;
  
  /** The padding length as BigInteger */
  public BigInteger padding_length;
  
  /** The padding length as int */
  public int padding_length_int;
  
  /** The payload as String. Contains the core submitted data of the packet. */
  public String payload;
  
  /** The random padding at the end of the packet for making the length of the
      packet a multiply of 8 or block size of the cipher algorithm, whichever
      is bigger.
  */      
  public String random_padding;
  
  /** The MAC String at the end of the packet. */  
  public String mac;
  
  /** Sequence number of this packet in the SSH2 stream. */
  public int sequenceNumber;

}