package com.monica.javacom.ssh2;

import com.monica.javacom.ssh2.*;
import com.monica.javacom.interfaces.*;
import com.monica.interfaces.*;
import com.monica.javacom.transport.*;
import com.monica.javacom.ssh2.interfaces.*;

import java.util.*;

public class SSH2Server extends SSH2BothSideFeatures implements Configureable {
    
    private SSH2ServerSide serverOwner;
    private Configuration configuration;    
    private SSH2ChannelManager channelManager;
    private Object cParam;
    
    public SSH2Server(Transport transport, SSH2Facade owner, SSH2ServerSide serverOwner, SSH2ChannelManager chManager, Object cParam) {
        this.transport=transport;
        this.owner=owner;
        this.serverOwner=serverOwner;
        this.channelManager=chManager;
        this.cParam=cParam;
        bsfInit();
        tokenizer=new SSH2Tokenizer(this, SSH2Constants.SSH_SIDE_SERVER);        
        tokenizer.setReadable(transport);
        tokenizer.setWriteable(transport);
        tokenizer.setCParam(cParam);
        tokenizer.setChannelManager(chManager);        
        transport.setReader(tokenizer);                        
    }

    protected void closeConnectionsImpl() {
        serverOwner.unRegisterServer(this);
    }
    
    public void start() {
        tokenizer.sendVersionString();
    }  
        
  // --------------------------------------------------------------
  // Configureable
  // --------------------------------------------------------------
  
  public void setConfiguration(Configuration configuration) {
    this.configuration=configuration;
    _processConfig();
  }

  public Configuration getConfiguration() {
    return configuration;
  }
  
  private void _processConfig() {
    transport.setConfiguration(configuration);
    tokenizer.setConfiguration(configuration);
  }
    
    
}
