package com.monica.javacom.ssh2;

import com.monica.javacom.interfaces.*;
import com.monica.javacom.transport.*;
import com.monica.javacom.application.*;
import com.monica.util.*;
import com.monica.javacom.ssh2.*;
import com.monica.interfaces.*;
import com.monica.util.configuration.*;
import com.monica.javacom.ssh2.interfaces.*;
import com.monica.javacom.ssh2.userauthentication.*;
import com.monica.javacom.ssh2.connection.*;
import com.monica.util.debug.*;

import java.io.*;
import java.util.*;

public class SSH2ServerImpl {
    
    private static final String DP="SSH2ServerImpl";
    
    private static final String CONF_NAME="JavaCom.ssh2server";
    
    private static Hashtable data;
    
    static {
        data=new Hashtable();
    }
    
    public static void startUp(Configuration loadedConfig, SSH2ChannelManager chManager) throws Exception {
        startUp(loadedConfig, chManager, null);
    }
    
    public static void startUp(Configuration loadedConfig, SSH2ChannelManager chManager, Object cParam) throws Exception {
        SSH2ServerSide serverSide=startUp_s1(loadedConfig, chManager, cParam);
        startUp_s2(serverSide);
    }
    
    public static SSH2ServerSide startUp_s1(Configuration loadedConfig, SSH2ChannelManager chManager, Object cParam) throws Exception {
        
        int port=loadedConfig.getConfiguration(CONF_NAME).getInt("listenPort");        
        
        DebugManager.logOut(DP, " ********** ");
        DebugManager.logOut(DP, " Listening to "+port);
        DebugManager.logOut(DP, " ********** ");
                                    
        SSH2Facade facade=new SSH2Facade();
	facade.setConfiguration(loadedConfig);
        
	SSH2ConfigurationManager ssh2configM=new SSH2ConfigurationManager(loadedConfig);
	ssh2configM.registerClasses(facade);
        SSH2ServerSide serverSide=facade.createServer(chManager, ssh2configM, cParam);           
        
        data.put(serverSide, ""+port);
        
        return serverSide;
    }
    
    public static void startUp_s2(SSH2ServerSide serverSide) throws Exception {
        int port=Integer.parseInt((String)(data.get(serverSide)));
        data.remove(serverSide);
        serverSide.startTransportLayer(port);
    }
    
}