package com.monica.javacom.ssh2.cipher;

import com.monica.javacom.interfaces.*;
import com.monica.interfaces.*;

/** Class for implementing the "none" ciphering method. This means no ciphering
    at all, eg. a transparent channel. 
*/
public class SSH2NoneCipher implements CipherAlgorithm {

  private static final String NAME="SSHNoneCipher";
  private static final String VERSION="0.2";

  public String getCipherAlgorithmName() {
    return NAME;
  }

  public String getCipherAlgorithmVersion() {
    return VERSION;
  }

  public String encode(String data) {
    return data;
  }

  public String decode(String encoded_data) {
    return encoded_data;
  }

  public int getCipherBlockSize() {
    return 1;
  }

  public Object getState() {
    return new Object();
  }

  public void setState(Object o) {
  }

  public void setKeys(String key, String iv) {
  }
  
  public void setConfiguration(Configuration configuration) {
  }
  
  public Configuration getConfiguration() {
    return null;
  }    

}