package com.monica.javacom.ssh2.compression;

import com.monica.interfaces.*;

/** Class for implementing the "none" compression method, eg. no compression at all.
*/
public class SSH2NoneCompression implements CompressionAlgorithm {

  private static final String NAME="SSHNoneCompression";
  private static final String VERSION="0.3";  

  public String getCompressionAlgorithmName() {
    return NAME;
  }

  public String getCompressionAlgorithmVersion() {
    return VERSION;
  }

  public String compress(String data) {
    return data;
  }

  public String decompress(String compressed_data) {
    return compressed_data;
  }
  
  public void setConfiguration(Configuration configuration) {
  }
  
  public Configuration getConfiguration() {
    return null;
  }    

}