package com.monica.javacom.ssh2.connection;

import com.monica.interfaces.*;
import com.monica.javacom.interfaces.*;
import com.monica.javacom.ssh2.*;
import com.monica.javacom.ssh2.interfaces.*;

public class SSH2BasicCFactory implements SSH2ConnectionLayerFactory {

  protected static final String NAME="SSH2BasicCFactory";
  protected static final String VERSION="0.31";
  
  protected static final String ERR_NOT_IMPLEMENTING="The specified parameter is not of type: ";
  
  protected String className;
  protected SSH2Facade facade;
  protected Configuration configuration;
  protected String[] mustImplement;
  
  public SSH2BasicCFactory(String className) {
    this.className=className;
  }
  
  public SSH2BasicCFactory(String className, String[] mustImplement) {
    this.className=className;
    this.mustImplement=mustImplement;
  }    
  
  public String getConnectionLayerFactoryName() {
    return NAME;
  }
  
  public String getConnectionLayerFactoryVersion() {
    return NAME;
  }
  
  public void setFacade(SSH2Facade facade) {
    this.facade=facade;
  }        
  
  public void setConfiguration(Configuration configuration) {
    this.configuration=configuration;
  }
  
  public Configuration getConfiguration() {
    return configuration;
  }      
  
  public SSH2ConnectionLayer getConnectionLayer(Object param) throws Exception {
    if (mustImplement!=null) {
      Class c;
      for (int i=0; i<mustImplement.length; i++) {
        c=Class.forName(mustImplement[i]);
	if (!c.isInstance(param)) {
	  throw new Exception(ERR_NOT_IMPLEMENTING+mustImplement[i]);
	}
      }	  
    }
    SSH2ConnectionLayer layer=getConnectionLayer();
    layer.setParam(param);
    return layer;
  }
  
  public SSH2ConnectionLayer getConnectionLayer() throws Exception {
    SSH2ConnectionLayer layer=(SSH2ConnectionLayer)Class.forName(className).newInstance();
    layer.setConfiguration(configuration);    
    return layer;
  }  
}          