package com.monica.javacom.ssh2.connection;

import com.monica.javacom.ssh2.connection.*;
import com.monica.javacom.ssh2.interfaces.*;
import com.monica.javacom.ssh2.*;

import java.util.*;

public class SSH2ClientChannel extends SSH2BasicChannel {

  public SSH2ClientChannel(SSH2ConnectionLayer connLayer) {
    _init(connLayer);  
  }

  public void channelRequest(SSH2Packet pack) {
    Vector dVector=io.parsePayload(pack.payload, SSH2Constants.CONN_CHANNEL_REQUEST_MSG_DATA_DESC);
    boolean wantReply=((Boolean)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_REQUEST_WANTREPLY)).booleanValue();
    if (wantReply) {    
      String toSend=io.wByte(SSH2Constants.SSH_CONNECTION_MSG_CHANNEL_FAILURE);
      toSend+=io.wUint32(partnerID);
      tokenizer.sendP(toSend);
    }
  }
  
  public void channelSuccess(SSH2Packet pack) {
  }
  
  public void channelFailure(SSH2Packet pack) {
    closeConnections();  
  }
  
}
