package com.monica.javacom.ssh2.connection;

import com.monica.javacom.ssh2.connection.*;
import com.monica.javacom.ssh2.*;
import com.monica.javacom.ssh2.interfaces.*;

import java.math.*;
import java.util.*;

public class SSH2ClientConnection extends SSH2BasicConnection {
    
  private SSH2Channel myChannel;  
  private SSH2ClientConnectionParam cParam;

  public SSH2ClientConnection() {
    _init();  
  }
  
  public void setParam(Object o) throws Exception {
    cParam=(SSH2ClientConnectionParam)o;    
  }
  
  public void start() {
    myChannel=new SSH2ClientChannel(this);
    myChannel.setOwnID(getNewChannelID());
    newChannel(myChannel.getOwnID(), myChannel);
    myChannel.setTokenizer(tokenizer);
    myChannel.setChannelManager(channelManager);
    myChannel.setConfiguration(configuration);
    
    String toSend=io.wByte(SSH2Constants.SSH_CONNECTION_MSG_CHANNEL_OPEN);
    toSend+=io.wString("session");
    toSend+=io.wUint32(myChannel.getOwnID());
    toSend+=io.wUint32(myChannel.getPartnerWindowSize());
    toSend+=io.wUint32(myChannel.getPartnerMaxPacketSize());
    tokenizer.sendP(toSend);
  }
  
  public SSH2Channel startNewChannel() {
      // TODO
      return null;
  }
  
  public SSH2Channel getNewChannel() {
      // TODO
      return null;
  }
  
  public void startChannel(SSH2Channel channel) {
      // TODO
  }
  
  public void processConnectionGlobalRequest(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
  public void processConnectionRequestSuccess(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);
  }
  
  public void processConnectionRequestFauilure(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
  public void processConnectionChannelOpen(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);    
  }
  
  public void processConnectionChannelOpenConfirmation(SSH2Packet pack) {
    Vector dVector=io.parsePayload(pack.payload, SSH2Constants.CONN_CHANNEL_OPEN_CONFIRMATION_MSG_DATA_DESC);        
    int recipient=((BigInteger)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_CONFIRMATION_RECIPIENT)).intValue();
    int sender=((BigInteger)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_CONFIRMATION_SENDER)).intValue();
    int windowSize=((BigInteger)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_CONFIRMATION_WINDOW)).intValue();
    int maxPacket=((BigInteger)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_CONFIRMATION_PACKET)).intValue();
    if (recipient!=myChannel.getOwnID()) {
      closeConnections();
    }
    myChannel.setPartnerID(sender);
    myChannel.setWindowSize(windowSize);
    myChannel.setMaxPacketSize(maxPacket);
    
    String ptyParam=io.wString(cParam.terminal.getType());
    ptyParam+=io.wUint32(cParam.display.getCSizeX());
    ptyParam+=io.wUint32(cParam.display.getCSizeY());
    ptyParam+=io.wUint32(0);
    ptyParam+=io.wUint32(0);
    ptyParam+=io.wString("");
                
    myChannel.request("pty-req", false, ptyParam);
    myChannel.request("shell", true, null);
    channelManager.channelReady(myChannel);
    tokenizer.connectionProtocolReady();
  }
  
  public void processConnectionChannelOpenFailure(SSH2Packet pack) {
    closeConnections();  
  }
  
  public void processConnectionChannelEOF(SSH2Packet pack) {
  }
  
  public void processConnectionChannelClose(SSH2Packet pack) {  
    closeConnections();
  }
  
  public void closeConnections() {
    tokenizer.closeConnections();
    System.exit(0);
  }
                     
}
