package com.monica.javacom.ssh2.connection;

import com.monica.javacom.ssh2.connection.*;
import com.monica.javacom.ssh2.interfaces.*;
import com.monica.javacom.ssh2.*;

import java.util.*;

public class SSH2ServerChannel extends SSH2BasicChannel {

  public SSH2ServerChannel(SSH2ConnectionLayer connLayer) {
    _init(connLayer);  
  }

  public void channelRequest(SSH2Packet pack) {
    Vector dVector=io.parsePayload(pack.payload, SSH2Constants.CONN_CHANNEL_REQUEST_MSG_DATA_DESC);
    String request=(String)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_REQUEST_REQUEST);
    boolean wantReply=((Boolean)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_REQUEST_WANTREPLY)).booleanValue();
    String toSend;
    boolean signalReady=false;
    if (wantReply) {    
      if (request.equals("pty-req")) {  
        toSend=io.wByte(SSH2Constants.SSH_CONNECTION_MSG_CHANNEL_SUCCESS);  
      }
      else if (request.equals("shell")) {  
        toSend=io.wByte(SSH2Constants.SSH_CONNECTION_MSG_CHANNEL_SUCCESS);  
        signalReady=true;        
      }
      else {
        toSend=io.wByte(SSH2Constants.SSH_CONNECTION_MSG_CHANNEL_FAILURE);
      }
      toSend+=io.wUint32(partnerID);
      tokenizer.sendP(toSend);
      if (signalReady) {
          channelManager.channelReady(this);
      }
    }
  }
  
  public void channelSuccess(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
  public void channelFailure(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
}
