package com.monica.javacom.ssh2.connection;

import com.monica.javacom.ssh2.connection.*;
import com.monica.javacom.ssh2.*;
import com.monica.javacom.ssh2.interfaces.*;

import java.math.*;
import java.util.*;

public class SSH2ServerConnection extends SSH2BasicConnection {
    
  private SSH2Channel myChannel;  
  private SSH2ClientConnectionParam cParam;

  public SSH2ServerConnection() {
    _init();  
  }
  
  public void start() {
  }
  
  public SSH2Channel startNewChannel() {
      // TODO
      return null;
  }
  
  public SSH2Channel getNewChannel() {
      // TODO
      return null;
  }
  
  public void startChannel(SSH2Channel ch) {
      // TODO
  }
  
  public void processConnectionGlobalRequest(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
  public void processConnectionRequestSuccess(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);
  }
  
  public void processConnectionRequestFauilure(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
  public void processConnectionChannelOpen(SSH2Packet pack) {      
    Vector dVector=io.parsePayload(pack.payload, SSH2Constants.CONN_CHANNEL_OPEN_MSG_DATA_DESC);        
    String type=(String)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_NAME);    
    
    if (type.equals("session")) {    
      int sender=((BigInteger)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_SENDER)).intValue();
      int windowSize=((BigInteger)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_WINDOW)).intValue();
      int packetSize=((BigInteger)dVector.elementAt(SSH2Constants.DI_CONN_CHANNEL_OPEN_PACKET)).intValue();
    
      SSH2ServerChannel channel=new SSH2ServerChannel(this);
    
      channel.setOwnID(getNewChannelID());
      newChannel(channel.getOwnID(), channel);
      channel.setTokenizer(tokenizer);
      channel.setChannelManager(channelManager);
      channel.setConfiguration(configuration);
            
      channel.setPartnerID(sender);
      channel.setWindowSize(windowSize);
      channel.setMaxPacketSize(packetSize);
    
      String toSend=io.wByte(SSH2Constants.SSH_CONNECTION_MSG_CHANNEL_OPEN_CONFIRMATION);
      toSend+=io.wUint32(sender);
      toSend+=io.wUint32(channel.getOwnID());
      toSend+=io.wUint32(channel.getPartnerWindowSize());
      toSend+=io.wUint32(channel.getPartnerMaxPacketSize());
      tokenizer.sendP(toSend);
    }
    else {
      tokenizer.sendUnimplementedMsg(pack);  
    }        
  }
  
  public void processConnectionChannelOpenConfirmation(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
  public void processConnectionChannelOpenFailure(SSH2Packet pack) {
    tokenizer.sendUnimplementedMsg(pack);  
  }
  
  public void processConnectionChannelEOF(SSH2Packet pack) {
  }
  
  public void processConnectionChannelClose(SSH2Packet pack) {  
    int channelNo=io.rUint32Int(pack.payload.substring(1));
    removeChannel(channelNo);
  }
  
}
