package com.monica.javacom.ssh2.interfaces;

import com.monica.javacom.ssh2.*;
import com.monica.interfaces.*;
import com.monica.javacom.interfaces.*;

public interface SSH2Channel extends LayerTopView, Closeable {

  public void setOwnID(int ID);
  public int getOwnID();
  public void setPartnerID(int ID);
  public int getPartnerID();
  public void setTokenizer(SSH2Tokenizer tokenizer);
  public SSH2Tokenizer getTokenizer();
     
  public String getInformation(int opt);
  public void setInformation(int opt, String value);
  public int getPartnerWindowSize();
  public int getPartnerMaxPacketSize();
  public void setWindowSize(int value);
  public void setMaxPacketSize(int value);
    
  public void modifyWindowSize(int value);
  public void data(String data);
  public void extendedData(String data);
  
  public void channelRequest(SSH2Packet pack);
  public void channelSuccess(SSH2Packet pack);
  public void channelFailure(SSH2Packet pack);
  
  public int request(String type, boolean wantReply, String other);  
  
  public void setChannelManager(SSH2ChannelManager chManager);
  public SSH2ChannelManager getChannelManager();
}

