package com.monica.javacom.ssh2.interfaces;

import com.monica.interfaces.*;
import com.monica.javacom.interfaces.*;
import com.monica.javacom.ssh2.*;
import com.monica.javacom.ssh2.interfaces.*;

public interface SSH2UserAuthenticationLayer extends SSH2Layer {
    
  /** Returns the SSH2 name of the type of this user authentication.
      @return String: the type of the user authentication
  */
  public String methodName();
    
  /** Returns the MJC name of the MJCSSHUserAuthLayer.
      @return String: the MJC name of the MJCSSHUserAuthLayer
  */
  public String getUserAuthenticationLayerName();
  
  /** Returns the MJC version of the MJCSSHUserAuthLayer.
      @return String: the MJC version of the MJCSSHUserAuthLayer
  */
  public String getUserAuthenticationLayerVersion();
  
  /** Starts this user authentication protocol. 
  */
  public void start() throws Exception;
  
  /** Indicates that an USERAUTH_REQUEST message has arrived.
      @param String: the payload of the message
  */
  public void processUserAuthRequestMsg(SSH2Packet pack) throws Exception;
  
  /** Indicates that an USERAUTH_SUCCESS message has arrived.
      @param String: the payload of the message
  */
  public void processUserAuthSuccessMsg(SSH2Packet pack) throws Exception;
  
  /** Indicates that an USERAUTH_FAILURE message has arrived.
      @param String: the payload of the message
  */
  public void processUserAuthFailureMsg(SSH2Packet pack) throws Exception;
  
  /** Indicates that an USERAUTH_BANNER message has arrived.
      @param String: the payload of the message
  */
  public void processUserAuthBannerMsg(SSH2Packet pack) throws Exception;
  
  /** Indicates that an USERAUTH_PK_OK message has arrived.
      @param String: the payload of the message
  */
  public void processUserAuthPkOkMsg(SSH2Packet pack) throws Exception;
  
  public boolean canContinue();
  
}

