package com.monica.javacom.ssh2.mac;

import com.monica.interfaces.*;

/** Class for implementing the "none" MAC algorithm, eg. no MAC at all. 
*/
public class SSH2NoneMAC implements MACAlgorithm {

  private static final String NAME="SSHNoneMAC";
  private static final String VERSION="0.3";

  public String getMACAlgorithmName() {
    return NAME;
  }

  public String getMACAlgorithmVersion() {
    return VERSION;
  }

  public String createMAC(String data, String secret) {
    return new String();
  }

  public boolean authenticate(String data, String MAC, String secret) {
    return true;
  }

  public int getMACLength() {
    return 0;
  }
  
  public void setConfiguration(Configuration configuration) {
  }
  
  public Configuration getConfiguration() {
    return null;
  }    
  
}