package com.monica.javacom.ssh2.userauthentication;

import com.monica.interfaces.*;
import com.monica.javacom.interfaces.*;
import com.monica.javacom.ssh2.*;
import com.monica.javacom.ssh2.interfaces.*;

import com.monica.util.debug.*;

public class SSH2BasicUAFactory implements SSH2UserAuthenticationLayerFactory {

  protected static final String NAME="SSH2BasicUAFactory";
  protected static final String VERSION="0.31";
  
  private static final String DP="SSH2BasicUAFactory";
  
  protected static final String ERR_NOT_IMPLEMENTING="The specified parameter is not of type: ";
  
  protected String className;
  protected SSH2Facade facade;
  protected Configuration configuration;
  protected String[] mustImplement;
  protected String methodName;
  
  public SSH2BasicUAFactory(String className) {
    this.className=className;
  }
  
  public SSH2BasicUAFactory(String className, String[] mustImplement, String methodName) {
    this.className=className;
    this.mustImplement=mustImplement;
    this.methodName=methodName;
  }    
  
  public String getUserAuthenticationLayerFactoryName() {
    return NAME;
  }
  
  public String getUserAuthenticationLayerFactoryVersion() {
    return NAME;
  }
  
  public void setFacade(SSH2Facade facade) {
    this.facade=facade;
  }        
  
  public void setConfiguration(Configuration configuration) {
    this.configuration=configuration;
  }
  
  public Configuration getConfiguration() {
    return configuration;
  }      
  
  public SSH2UserAuthenticationLayer getUserAuthenticationLayer(Object param) throws Exception {
    if (mustImplement!=null) {
      Class c;
      for (int i=0; i<mustImplement.length; i++) {
        c=Class.forName(mustImplement[i]);
	if (!c.isInstance(param)) {
	  throw new Exception(ERR_NOT_IMPLEMENTING+mustImplement[i]);
	}
      }	  
    }
    SSH2UserAuthenticationLayer layer=getUserAuthenticationLayer();
    layer.setParam(param);
    return layer;
  }
  
  public SSH2UserAuthenticationLayer getUserAuthenticationLayer() throws Exception {
    SSH2UserAuthenticationLayer layer=(SSH2UserAuthenticationLayer)Class.forName(className).newInstance();
    layer.setConfiguration(configuration);    
    return layer;
  }
  
  public String getUserAuthenticationMethodName() {
    return methodName;
  }
}          