package com.monica.javacom.transport;

/** Provides constants for describing the connection status of a MJCTransport.
*/
public final class TransportConstants {

  // Status constants

  /** The MJCTransport is not connected to any other party.
  */
  public static final int NOT_CONNECTED=0; // status: not connected

  /** The MJCTransport runs in an own thread as a server part for a client.
  */
  public static final int CONNECTED_SERVER=1; // status: connected as server in a new thread

  /** The MJCTransport runs in an own thread as a client part for a server.
  */
  public static final int CONNECTED_CLIENT=2; // status: connected as client in a new thread

  /** The MJCTransport is not connected to any other party, but was previously and there is
      data in the read buffer that hasn't been read out yet.
  */
  public static final int NOT_CONNECTED_WITH_DATA_WAITING=3; // status: not connected any more but data is waiting for to be read out

  /** The MJCTransport runs a accepting server, that means it is able to establish
      connections for arriving new clients.
  */
  public static final int ACCEPTING_SOCKETS=4;

}


