package com.monica.util;

/** Provides functionality of holding an Exception. This is useful when a new Exception is thrown 
 *  upon an old one, but the information contained in the old one should be kept.
 */

public interface ExceptionHolder {
   
    /** Sets the to be kept Exception.
     *  @param Exception e: the to be kept Exception
     */
    public void setException(Exception e);
    
    /** Returns the to be kept Exception.
     *  @return Exception: the to be kept Exception
     */
    public Exception getException();
    
}
