package com.monica.util;

import com.monica.interfaces.*;

import java.awt.*;

/** Class responsible for holding an Image.
*/
public class ImageCanvas extends Component {

  private Image image;
  private int width, height;

  /** Constructor. The Image to hold has to be specified.
      @param Image i: the Image to hold
  */
  public ImageCanvas(Image i, int w, int h) {
    image = i;
    width=w;
    height=h;
    setSize(new Dimension(width, height));
  }
  
  public Dimension getMinimumSize() {
      return new Dimension(width, height);
  }
  
  public Dimension getPreferredSize() {
      return new Dimension(width, height);
  }
  
  
/*  public Dimension getMinimumSize() {
    return getPreferredSize();
  }
  
  public Dimension getPreferredSize() {
    int width  = -1;
    int height = -1;
    boolean ready = false;

    while (!ready) {
      width  = image.getWidth(null);
      height = image.getHeight(null);
      if(width != -1 && height != -1) {
        ready = true;
      }
      Thread.yield();
    }
    Dimension dim = new Dimension(width, height);
    return dim;
  } */

  public void paint(Graphics g) {
/*    if (image == null) {
      return;
    }
    Dimension d = getSize(); 
    g.drawImage(image, 0, 0, d.width, d.height, this); */
    Dimension d=getSize();
    int w, h;
    w=(int)(d.getWidth());
    h=(int)(d.getHeight());
    g.drawImage(image, (int)((w-width)/2), (int)((h-height)/2), this);
  }
  
}

