package com.monica.util;

import com.monica.util.debug.*;

import java.io.*;
import java.util.*;

public class StringOutputStream extends OutputStream {
    
    // -------------------------------------------------------------------------
    // Variables and constants
    // -------------------------------------------------------------------------
    
    private static final String DP="StringOutputStream";
    
    private Vector data;
    private int len;
    
    private boolean closed;
    
    // -------------------------------------------------------------------------
    // Constructor
    // -------------------------------------------------------------------------
    
    public StringOutputStream() {
        data=new Vector();
        len=0;
        closed=false;
    }
    
    // -------------------------------------------------------------------------
    // Public methods
    // -------------------------------------------------------------------------
        
    public String getString() {
        byte b[]=new byte[len];
        int size=data.size();
        byte bb[];
        int pos=0;
        for (int i=0; i<size; i++) {
            bb=(byte[])(data.elementAt(i));
            System.arraycopy(bb, 0, b, pos, bb.length);
            pos+=bb.length;
        }
        return new String(b);
    }
    
    public void reset() {
        data=new Vector();
        len=0;
        closed=false;
    }
    
    public int length() {
        return len;
    }
    
    // -------------------------------------------------------------------------
    // OutputStream
    // -------------------------------------------------------------------------
    
    public void write(int param) throws IOException {
        byte b[]=new byte[1];
        b[0]=(byte)(param);
        write(b, 0, 1);
    }    
    
    public void write(byte[] b) throws IOException {
        write(b, 0, b.length);
    }
    
    public void write(byte[] b, int offset, int len) throws IOException {
        if (closed) {
            throw new IOException("OutputStream closed.");
        }
        byte bb[]=new byte[len];
        System.arraycopy(b, offset, bb, 0, len);
        data.addElement(bb);
        this.len+=len;
    }
    
    public void flush() {
    }
    
    public void close() {
        closed=true;
    }
    
}
