package com.monica.util.ccdm;

import com.monica.interfaces.*;

public interface CCDCipherAlgorithm extends Configureable {
    
    public String getName();
    public CCDCipherParamDesc[] supportedModes();
    
    public CCDCipherParamDesc init(CCDKey key, CCDIV IV) throws CCDException;
    
    public void encipherArrived(String from) throws CCDException;
    public void decipherArrived(String from) throws CCDException;
    
    public String encipherFlush() throws CCDException;
    public String decipherFlush() throws CCDException;
    
    public Object getState();
    public Object setState() throws CCDException;
        
    public String encipher(String from, CCDKey key, CCDIV IV) throws CCDException;
    public String decipher(String from, CCDKey key, CCDIV IV) throws CCDException;
    
}
