package com.monica.util.ccdm;

import com.monica.interfaces.*;

public interface CCDManager extends Configureable, Closeable {
    
    public CCDKey[] getKey(CCDOwner owner) throws CCDException;
    public CCDKey[] getKey(CCDOwner owner, String keyType) throws CCDException;
    public CCDKey[] getKey(CCDOwner owner, String keyType, String designation) throws CCDException;
    public CCDKey[] getKey(String designation) throws CCDException;
    
    public void putKey(CCDKey key) throws CCDException;
    
    public void registerSignatureAlgorithm(String signatureAlgorithmClass, String[] keyNames, String[] signatureNames) throws CCDException;
    public CCDSignatureAlgorithm createSignatureAlgorithm(CCDKey key) throws CCDException;
    public CCDSignatureAlgorithm createSignatureAlgorithm(CCDSignature signature) throws CCDException;        
    
    public void registerSignature(String signatureClass) throws CCDException;
    public CCDSignature createSignature(String type, String core, CCDOwner issuer) throws CCDException;
}
