package com.monica.util.ccdm.ciphers;

import com.monica.interfaces.*;
import com.monica.util.debug.*;

public class XORCipher implements CipherAlgorithm {
    
    private static final String NAME="XORCipher";
    private static final String VERSION="0.1";
    
    private static final String DP="XORCipher";
    
    private class XORCipherStatus {
        public int kPos;
    }
    
    private char[] key;
    
    private XORCipherStatus status;
    
    private Configuration myConfig;
    
    public XORCipher() {
        status=new XORCipherStatus();
        status.kPos=0;
    }
    
    // ---------------------------------------------------------------
    // CipherAlgorithm 
    // ---------------------------------------------------------------
    
    public String getCipherAlgorithmName() {
        return NAME;
    }
    
    public String getCipherAlgorithmVersion() {
        return VERSION;
    }
    
    public int getCipherBlockSize() {
        return 1;
    }    
    
    public void setKeys(String Key, String IV) {
        key=Key.toCharArray();
    }
    
    public String encode(String data) {
        return _xor(data);
    }
        
    public String decode(String coded_data) {
        return _xor(coded_data);
    }
    
    public Object getState() {
        return status;
    }
            
    public void setState(Object state) {
        status=(XORCipherStatus)(state);
    }
    
    // ---------------------------------------------------------------
    // Configureable
    // ---------------------------------------------------------------
    
    public void setConfiguration(Configuration configuration) {
        myConfig=configuration;
        _rereadConfig();
    }
    
    public Configuration getConfiguration() {
        return myConfig;
    }
    
    // ---------------------------------------------------------------
    // CipherAlgorithm 
    // ---------------------------------------------------------------
    
    private void _rereadConfig() {
    }
    
    private String _xor(String data) {
        
        char[] oa=data.toCharArray();
        char[] resa=new char[oa.length];
        
        for (int i=0; i<resa.length; i++) {
            resa[i]=(char)(((int)(oa[i]))^((int)(key[status.kPos])));
            status.kPos++;
            if (status.kPos==key.length) {
                status.kPos=0;
            }
        }
        return new String(resa);
    }
                      
}
