package com.monica.util.ccdm.impl;

import com.monica.util.ccdm.*;
import com.monica.interfaces.*;
import com.monica.util.debug.*;

/**
 *  initialization from a Configuration
 *      UID
 *      DN
 *      CN
 */

public class CCDBasicOwner implements CCDOwner {
    
    private static final String DP="CCDBasicOwner";
    
    private String myCN, myDN, myUID;
    
    public CCDBasicOwner() {
    }
    
    public CCDBasicOwner(Configuration conf) {
        String s;
        
        // UID
        try {
            s=conf.getString("UID");
            setUID(s);
        }
        catch (Exception e) {
            DebugManager.logOut(DP, "UID not found in the configuration.");
        }
        
        // DN
        try {
            s=conf.getString("DN");
            setDN(s);
        }
        catch (Exception e) {
            DebugManager.logOut(DP, "DN not found in the configuration.");
        }
        
        // CN
        try {
            s=conf.getString("CN");
            setCN(s);
        }
        catch (Exception e) {
            DebugManager.logOut(DP, "CN not found in the configuration.");
        }
        
            
    }
    
    public CCDBasicOwner(String cn, String dn, String uid) {
        myCN=cn;
        myDN=dn;
        myUID=uid;
    }
    
    public String getCN() {
        return myCN;
    }
    
    public String getDN() {
        return myDN;
    }
    
    public String getUID() {
        return myUID;
    }
    
    public void setCN(String cn) {
        myCN=cn;
    }
    
    public void setDN(String dn) {
        myDN=dn;
    }
    
    public void setUID(String uid) {
        myUID=uid;
    }
    
}
