package com.monica.util.ccdm.impl;

import com.monica.util.ccdm.*;

/**
 *  Class for implementing a simple funtionality CCDSignatureParamDesc.
 */
public class CCDSimpleSignatureParamDesc implements CCDSignatureParamDesc {
    
    private boolean b_canSign, b_canVerify;
    private int i_getLength;
    private String s_getName;
   
    /**
     *  Default constructor. The values that the get methods supply can
     *  be set as parameters.
     *  @param String name: the value that the getName method will return
     *  @param int length: the value that the getLength method will return
     *  @param boolean sign: the value that the canSign method will return
     *  @param boolean verify: the value that the canVerify method will return
     */
    public CCDSimpleSignatureParamDesc(String gn, int gl, boolean cs, boolean cv) {
        s_getName=gn;
        i_getLength=gl;
        b_canSign=cs;
        b_canVerify=cv;
    }
    
    // -----------------------------------------------------------------
    // CCDSimpleSignatureParamDesc
    // -----------------------------------------------------------------
    
    /**
     *  Sets the value that the canSign method will return.
     *  @param boolean sign: the value that the canSign method will return
     */
    public void setCanSign(boolean b) {
        b_canSign=b;
    }
    
    /**
     *  Sets the value that the canVerify method will return.
     *  @param boolean verify: the value that the canVeirfy method will return
     */
    public void setCanVerify(boolean b) {
        b_canVerify=b;
    }
    
    /**
     *  Sets the value that the getLength method will return.
     *  @param int length: the value that the getLength method will return
     */
    public void setGetLength(int i) {
        i_getLength=i;
    }
    
    /**
     *  Sets the value that the getName method will return.
     *  @param String name: the value that the getName method will return
     */
    public void setGetName(String s) {
        s_getName=s;
    }
            
    // -----------------------------------------------------------------
    // CCDManager
    // -----------------------------------------------------------------
        
    public boolean canSign() throws CCDException {
        return b_canSign;
    }
    
    public boolean canVerify() throws CCDException {
        return b_canVerify;
    }
    
    public int getLength() {
        return i_getLength;
    }
    
    public String getName() throws CCDException {
        return s_getName;
    }
    
}
