package com.monica.util.configuration;

import com.monica.util.configuration.InputStreamConfiguration;

import java.io.FileInputStream;

/** This class implements the Configuration interface to provide customization possibility
    for TM classes. This class reads customization information from a file called TM.conf,
    which has to be located in the current directory.<br><br>
    The configuration file can have the following stucure:<br>
    <ul>
      <li>lines beginning with # are recognized as comments and therefore ignored
      <li>lines not beginning with # are recognized as configuration lines<br><br>
        configuration lines have the following structure:<br>
        <pre>keyword=value</pre>
        Values can be Strings, ints, and booleans. Booleans are represented with the
        strings "true" and "false". These values can be referenced int he get methods
        of the Configuration with the id matching the keyword.
    </ul>
*/
public class FileConfiguration extends InputStreamConfiguration {

  // constants
  private static final String defaultConfFileName="TM.conf";

  private static final String NAME="FileConfiguration";
  private static final String VERSION="0.3";

  public String getConfigurationName() {
    return NAME;
  }

  public String getConfigurationVersion() {
    return VERSION;
  }

  /** Default constructor.
  */
  public FileConfiguration() {
    pre_init();
    try {
      iS=new FileInputStream(defaultConfFileName);
      post_init();
    }
    catch (Exception e) {
    }
  }

  public FileConfiguration(String fileName) {
    pre_init();
    try {
      iS=new FileInputStream(fileName);
      post_init();
    }
    catch (Exception e) {
    }
  }

}