package com.monica.util.configuration;

import com.monica.util.configuration.InputStreamConfiguration;

/** Class providing Configuration functionality using InputStreamConfiguration
    methodics and reading the configuration data from a String.<br><br>

    The configuration String can have the following stucure:<br>
    <ul>
      <li>lines beginning with # are recognized as comments and therefore ignored
      <li>lines not beginning with # are recognized as configuration lines<br><br>
        configuration lines have the following structure:<br>
        <pre>keyword=value</pre>
        Values can be Strings, ints, and booleans. Booleans are represented with the
        strings "true" and "false". These values can be referenced int he get methods
        of the Configuration with the id matching the keyword.
    </ul>
*/

public class StringConfiguration extends InputStreamConfiguration {

  // constants
  private static final String NAME="StringConfiguration";
  private static final String VERSION="0.3";

  public String getConfigurationName() {
    return NAME;
  }

  public String getConfigurationVersion() {
    return VERSION;
  }

  /** Default constructor.
  */
  public StringConfiguration(String s) {
    pre_init();
    try {
      iS=new com.monica.util.StringInputStream(s);
      post_init();
    }
    catch (Exception e) {
    }
  }
}